#ifndef EVENT_H
#define EVENT_H

#include <QIODevice>
#include <QString>
#include <vector>

#include "group.h"
#include "results.h"
#include "rpfile.h"
#include "xml_index.h"

class XkorEvent
{
	private:
		QString name;
		QString sportname;
		QString rpfilename;
		std::vector<QString> startLists;
		std::vector<XkorGroup> groups;
		bool headtohead;
		QString outputType;
		XkorConfig bonuses;
		
		void loadFile(QIODevice * dev);
	public:
		XkorEvent() {;;;}
		XkorEvent(QString filename) throw(XkorFileNotFoundException);
		XkorEvent(QIODevice * dev);
		QString getName();
		QString getConfigFileName();
		QString getSport();
		QString getOutputType();
		std::vector<XkorGroup> getGroups();
		std::vector<QString> getStartLists();
		XkorResults makeStartLists(XkorXmlIndex results_ind);
		void setHeadtohead(bool h2h);
		QString getStartListDirectory();
};

#endif
