#include "eventeditor/startlistwidget.h"

#include <QGridLayout>
#include <QInputDialog>
#include "eventeditor/startlistdelegate.h"

XkorStartListWidget::XkorStartListWidget()
{
	treeWidget->setItemDelegate(new XkorStartListDelegate(&availableStartLists));
	treeWidget->setColumnCount(1);
	treeWidget->setSortingEnabled(true);
	treeWidget->sortItems(0, Qt::AscendingOrder);
	treeWidget->setHeaderHidden(true);
	
	setupLayout();
}

void XkorStartListWidget::initItem(QTreeWidgetItem * item, QString startList)
{
	item->setText(0, startList);
}

void XkorStartListWidget::setAvailableStartLists(QStringList l)
{
	availableStartLists = l;
	updateButtons();
}

void XkorStartListWidget::setStartLists(std::vector<QString> startLists)
{
	isInUse = true;
	for(std::vector<QString>::iterator i = startLists.begin(); i != startLists.end(); ++i)
		initItem(createItem(), *i);
	isInUse = false;
	emit listChanged();
}

void XkorStartListWidget::setupLayout()
{
	layout = new QGridLayout(this);
	layout->addWidget(treeWidget, 0, 0, 5, 1);
	layout->addWidget(insertButton, 1, 1);
	layout->addWidget(deleteButton, 3, 1);
}

std::vector<QString> XkorStartListWidget::startLists()
{
	std::vector<QString> rval;
	for(QTreeWidgetItemIterator i(treeWidget); *i; ++i)
		rval.push_back((*i)->text(0));
	return rval;
}
