#ifndef ATHLETICS_FIELD_H
#define ATHLETICS_FIELD_H

struct XkorOutputAthleticsField
{
	static QString output(XkorResults * r)
	{
		QString rval;
		for(vector<XkorResultsGroup>::iterator i = r->groups.begin(); i != r->groups.end(); ++i)
		{
			rval += i->name;
			rval += "\n";
			for(vector<XkorAthlete>::iterator j = i->athletes.begin(); j != i->athletes.end(); ++j)
			{
				QString athletename = j->name;
				athletename += " (";
				athletename += j->nation;
				athletename += ") ";
				rval += athletename.leftJustified(48);
				if(j->results[1] == 1) // DNF
					rval += QString("NM").rightJustified(10);
				else if(j->results[2] == 1) // DQ
					rval += QString("DQ").rightJustified(10);
				else
					rval += QString::number(j->results[0], 'f', r->precision[0]).rightJustified(10);
				if(j->results[4] == 1) // DNF
					rval += QString("NM").rightJustified(10);
				else if(j->results[5] == 1) // DQ
					rval += QString("DQ").rightJustified(10);
				else
					rval += QString::number(j->results[3], 'f', r->precision[3]).rightJustified(10);
				if(j->results[7] == 1) // DNF
					rval += QString("NM").rightJustified(10);
				else if(j->results[8] == 1) // DQ
					rval += QString("DQ").rightJustified(10);
				else
					rval += QString::number(j->results[6], 'f', r->precision[6]).rightJustified(10);
				rval += "\n";
			}
			rval += "\n";
		}
		return rval;
	}
};

#endif
