#ifndef BASEBALL_H
#define BASEBALL_H

struct XkorOutputBaseball
{
	static QString output(XkorResults * r)
	{
		QString rval;
		for(vector<XkorResultsGroup>::iterator i = r->groups.begin(); i != r->groups.end(); ++i)
		{
			rval += i->name;
			rval += "\n";
			int acc = 0;
			for(vector<XkorAthlete>::iterator j = i->athletes.begin(); j != i->athletes.end(); ++j)
			{
				if(acc & 1) // only give output for every other athlete
				{
					// find the last athlete
					vector<XkorAthlete>::iterator prev = j;
					--prev;
					
					rval += prev->name;
					rval += " ";
					
					bool et = false;
					if(prev->results[0] == j->results[0])
						et = true;
					
					if(et)
					{
						double t1score = prev->results[0], t2score = j->results[0];
						for(int k = 1; k < 11; ++k)
						{
							t1score += prev->results[k];
							t2score += j->results[k];
							if(t1score != t2score)
								break;
						}
						if(t1score == t2score)
						{
							// we ran out of overtimes, so we’re cheating
							if(prev->scorinated_results[0] > j->scorinated_results[0])
								++t1score;
							else
								++t2score;
						}
						rval += QString::number(t1score, 'f', r->precision[1]);
						rval += "–";
						rval += QString::number(t2score, 'f', r->precision[1]);
					}
					else
					{
						rval += QString::number(prev->results[0], 'f', r->precision[0]);
						rval += "–";
						rval += QString::number(j->results[0], 'f', r->precision[0]);
					}
					rval += " ";
					rval += j->name;
					rval += "\n";
				}
				++acc;
			}
		}
		return rval;
	}
};

#endif
