#ifndef BOXING_H
#define BOXING_H

struct XkorOutputBoxing
{
	static QString output(XkorResults * r)
	{
		QString rval;
		for(vector<XkorResultsGroup>::iterator i = r->groups.begin(); i != r->groups.end(); ++i)
		{
			rval += i->name;
			rval += "\n";
			int acc = 0;
			for(vector<XkorAthlete>::iterator j = i->athletes.begin(); j != i->athletes.end(); ++j)
			{
				if(acc & 1) // only give output for every other athlete
				{
					// find the last athlete
					vector<XkorAthlete>::iterator prev = j;
					--prev;
					
					double t1rscos = RandomLib::Random::Global.Fixed<double>(), t2rscos = RandomLib::Random::Global.Fixed<double>(), t1rsci = RandomLib::Random::Global.Fixed<double>(), t2rsci = RandomLib::Random::Global.Fixed<double>();
					
					bool rscos = false, rsci = false;
					bool winner = false; // false = prev, true = j
					// referee stopped contest?
					if(t1rscos < prev->results[1] && t2rscos >= j->results[1] && t1rsci >= prev->results[3] && t2rsci >= j->results[3]) // prev lost by RSCOS
					{
						rscos = true;
						winner = true;
					}
					else if(t1rscos >= prev->results[1] && t2rscos >= j->results[1] && t1rsci < prev->results[3] && t2rsci >= j->results[3]) // prev lost by RSCI
					{
						rsci = true;
						winner = true;
					}
					else if(t1rscos >= prev->results[1] && t2rscos < j->results[1] && t1rsci >= prev->results[3] && t2rsci >= j->results[3]) // j lost by RSCOS
						rscos = true;
					else if(t1rscos >= prev->results[1] && t2rscos >= j->results[1] && t1rsci >= prev->results[3] && t2rsci < j->results[3]) // j lost by RSCI
						rsci = true;
					
					rval += prev->name;
					rval += " ";
					if(rscos || rsci)
						rval += (winner ? "def. by" : "def.");
					else
					{
						if(prev->results[0] == j->results[0] && prev->scorinated_results[0] > j->scorinated_results[0]) // decision
							rval += "+";
						rval += QString::number(prev->results[0], 'f', r->precision[0]);
						rval += "–";
						rval += QString::number(j->results[0], 'f', r->precision[0]);
						if(prev->results[0] == j->results[0] && prev->scorinated_results[0] <= j->scorinated_results[0]) // decision
							rval += "+";
					}
					rval += " ";
					rval += j->name;
					if(rscos)
					{
						rval += " (RSCOS R";
						if(winner) // prev lost
							rval += rscFormat(prev->results[2]);
						else
							rval += rscFormat(j->results[2]);
						rval += ")";
					}
					else if(rsci)
					{
						rval += " (RSCI R";
						if(winner)
							rval += rscFormat(prev->results[4]);
						else
							rval += rscFormat(j->results[4]);
						rval += ")";
					}
					rval += "\n";
				}
				++acc;
			}
		}
		return rval;
	}
	
	private:
		static QString rscFormat(double time)
		{
			QString rval;
			rval += QString::number(4 - (int)(time / 120));
			rval += " ";
			rval += QString::number((int)(120 - (int)time % 120) / 60);
			rval += ":";
			if((int)time % 60 >= 50)
				rval += "0";
			rval += ((int)time % 60 == 0 ? "00" : QString::number((int)(60 - (int)time % 60)));
			return rval;
		}
};

#endif
