#ifndef FENCING_H
#define FENCING_H

#include <iostream>

struct XkorOutputFencing
{
	static QString output(XkorResults * r, int scoreLimit, int timeLimit)
	{
		QString rval;
		for(vector<XkorResultsGroup>::iterator i = r->groups.begin(); i != r->groups.end(); ++i)
		{
			rval += i->name;
			rval += "\n";
			int acc = 0;
			for(vector<XkorAthlete>::iterator j = i->athletes.begin(); j != i->athletes.end(); ++j)
			{
				if(acc & 1) // only give output for every other athlete
				{
					// find the last athlete
					vector<XkorAthlete>::iterator prev = j;
					--prev;
					
					rval += prev->name;
					rval += " ";
					double t1score = 0, t2score = 0;
					for(int count = 0; t1score < scoreLimit && t2score < scoreLimit && count < timeLimit; ++count)
					{
						double t1rand = RandomLib::Random::Global.Fixed<double>();
						double t2rand = RandomLib::Random::Global.Fixed<double>();
						if(t1rand < prev->results[0] && t2rand >= j->results[0])
							++t1score;
						else if(t1rand >= prev->results[0] && t2rand < j->results[0])
							++t2score;
						std::cerr << t1score << "–" << t2score << std::endl;
					}
					while(t1score == t2score)
					{
						double t1rand = RandomLib::Random::Global.Fixed<double>();
						double t2rand = RandomLib::Random::Global.Fixed<double>();
						if(t1rand < prev->results[0] && t2rand >= j->results[0])
							++t1score;
						else if(t1rand >= prev->results[0] && t2rand < j->results[0])
							++t2score;
						std::cerr << "OT " << t1score << "–" << t2score << std::endl;
					}
					rval += QString::number(t1score);
					rval += "–";
					rval += QString::number(t2score);
					rval += " ";
					rval += j->name;
					rval += "\n";
				}
				++acc;
			}
		}
		return rval;
	}
};

#endif
