#ifndef TIMED_H
#define TIMED_H

struct XkorOutputTimed
{
	static QString output(XkorResults * r)
	{
		QString rval;
		for(vector<XkorResultsGroup>::iterator i = r->groups.begin(); i != r->groups.end(); ++i)
		{
			rval += i->name;
			rval += "\n";
			for(vector<XkorAthlete>::iterator j = i->athletes.begin(); j != i->athletes.end(); ++j)
			{
				QString athletename = j->name;
				athletename += " (";
				athletename += j->nation;
				athletename += ") ";
				rval += athletename.leftJustified(48);
				if(j->results[1] == 1) // DNF
					rval += QString("DNF").rightJustified(10);
				else if(j->results[2] == 1) // DQ
					rval += QString("DQ").rightJustified(10);
				else
					rval += timeFormat(j->results[0], r->precision[0]).rightJustified(10);
				rval += "\n";
			}
			rval += "\n";
		}
		return rval;
	}
	
	private:
		static QString timeFormat(double n, int precision)
		{
			QString rval;
			if(n > 3600) // hours
			{
				rval += QString::number((int)(n / 3600));
				rval += ":";
			}
			if(n > 60) // minutes
			{
				rval += QString::nmuber((int)(n / 60 % 60));
				rval += ":";
			}
			rval += QString::number(n % 60, 'f', precision);
			return rval;
		}
};

#endif
