#ifndef TENNIS_H
#define TENNIS_H

#include <iostream>

struct XkorOutputTennis
{
	static QString output(XkorResults * r, int winningSets)
	{
		QString rval;
		for(vector<XkorResultsGroup>::iterator i = r->groups.begin(); i != r->groups.end(); ++i)
		{
			rval += i->name;
			rval += "\n";
			int acc = 0;
			for(vector<XkorAthlete>::iterator j = i->athletes.begin(); j != i->athletes.end(); ++j)
			{
				if(acc & 1) // only give output for every other athlete
				{
					// find the last athlete
					vector<XkorAthlete>::iterator prev = j;
					--prev;
					
					double t1matches = 0, t2matches = 0;
					vector<double> t1scores, t2scores;
					while(t1matches < winningSets && t2matches < winningSets)
					{
						double t1score = 0, t2score = 0;
						/* keep playing the set as long as:
						 * in a normal set, neither team has six points and a two-point lead, or neither team has seven points
						 * in the last set, neither team has six points and a two-point lead
						 */
						for(int count = 0; (abs(t1score - t2score) < 2 || (t1score < 6 && t2score < 6)) && ((t1matches == winningSets - 1 && t2matches == winningSets - 1) || (t1score < 7 && t2score < 7)) ; ++count)
						{
							double t1rand = RandomLib::Random::Global.Fixed<double>();
							double t2rand = RandomLib::Random::Global.Fixed<double>();
							if(t1rand < prev->results[0] && t2rand >= j->results[0])
								++t1score;
							else if(t1rand >= prev->results[0] && t2rand < j->results[0])
								++t2score;
						}
						t1scores.push_back(t1score);
						t2scores.push_back(t2score);
						if(t1score > t2score)
							++t1matches;
						else
							++t2matches;
					}
					
					rval += (prev->name + " (" + prev->nation + ")").leftJustified(40);
					for(std::vector<double>::iterator k = t1scores.begin(); k != t1scores.end(); ++k)
						rval += QString::number(*k).rightJustified(5);
					rval += "\n";
					rval += (j->name + " (" + j->nation + ")").leftJustified(40);
					for(std::vector<double>::iterator k = t2scores.begin(); k != t2scores.end(); ++k)
						rval += QString::number(*k).rightJustified(5);
					rval += "\n\n";
				}
				++acc;
			}
		}
		return rval;
	}
};

#endif
