#ifndef TIMED_H
#define TIMED_H

#include "outputformats/outputformatbase.h"

struct XkorOutputTimed : public XkorAbstractOutputFormat
{
	public:
		XkorOutputTimed(QString s1 = QString(), QString s2 = QString(), QString lap = QString()) : status1Name(s1), status2Name(s2), lappedName(lap) {;;;}
		
	private:
		QString status1Name, status2Name, lappedName;
		
		QString individualResult(XkorSport & s, double skill, double style, double bonus)
		{
			QString rval;
			if(status1Name != NULL && s.individualScore(1, skill, style, bonus) == 1)
				rval = QString(status1Name);
			else if(status2Name != NULL && s.individualScore(2, skill, style, bonus) == 1)
				rval = QString(status2Name);
			else
			{
				double score = s.individualScore(0, skill, style, bonus);
				if(lappedName != NULL && score == 109300) // LAP
					rval = QString(lappedName);
				else
					rval = timeFormat(score, s.displayDigits(0));
			}
			return rval;
		}
		
		uint requiredValues()
		{
			return 1 + (status1Name.isEmpty() ? 0 : 1) + (status2Name.isEmpty() ? 0 : 1); 
		}
};

#endif
