#ifndef SPORT_H
#define SPORT_H

#include <map>
#include <vector>
#include <QString>

class XkorSport
{
	private:
		QString name;
		std::vector<std::map<double, double> > dataPoints;
		std::vector<uint> digits;
		std::vector<double> prec;
		std::vector<QString> scoreType;
		
		double rand_kumaraswamy(double a, double b, bool skew);
		double rand_triangular(double a, double c, double b);
		double score(uint index, double skill, double style, double minConstant, double midConstant, double maxConstant, bool skew);
		double transformNumber(double x, uint index) const;
	public:
		XkorSport(QString filename);
		uint countValues() const { return dataPoints.size(); }
		uint displayDigits(uint index) const { return digits.at(index); }
		QString getName() const { return name; }
		double h2hScore(uint index, double skill, double style, double rp, double oppSkill, double oppStyle, double oppRp);
		double individualScore(uint index, double skill, double style, double rp);
		double precision(uint index) const { return prec.at(index); }
};

#endif
