#ifndef ATHLETEWIDGET_H
#define ATHLETEWIDGET_H

#include <QAction>
#include <QToolButton>
#include <set>

#include "abstracttreewidget.h"
#include "athlete.h"

class XkorAthleteWidget : public XkorAbstractTreeWidget
{
	Q_OBJECT
	
	protected:
		QAction * importAction;
		QToolButton * importButton;
		
		virtual void initItem(QTreeWidgetItem * item) { initItem(item, QString(), QString(), QString(), 0, 0); }
		virtual void initItem(QTreeWidgetItem * item, QString athleteName, QString shortName, QString nation, double skill, double style);
		virtual void setupLayout();
		virtual QString insertionText() { return tr("Add athlete"); }
		virtual QString deletionText() { return tr("Remove athletes"); }
		
	protected slots:
		void importAthletes();
	
	public:
		XkorAthleteWidget();
		std::set<XkorAthlete> athletes();
		void setAthletes(std::set<XkorAthlete> athletes);
};

#endif
