#ifndef STARTLISTEDITOR_H
#define STARTLISTEDITOR_H

#include <QLineEdit>

#include "startlisteditor/athletewidget.h"

class XkorStartListEditor : public QWidget
{
	Q_OBJECT
	
	private:
		QLineEdit * startListName;
		XkorAthleteWidget * athletes;
		QString currentFileName;
		bool fileIsModified;
	private slots:
		bool okayToLoad();
		void setModified(bool isModified = true);
		void writeFile(QIODevice * dev);
	public:
		XkorStartListEditor(QWidget * parent = 0);
	signals:
		void fileChanged(QString filename); // loaded a new file
		void fileEdited(bool isModified); // changed the current file
	public slots:
		void openFile();
		void saveFile(QString filename = QString());
		void saveFileAs();
};

#endif
