#include "tablegenerator/matchdelegate.h"

#include <QLineEdit>
#include <QSpinBox>

QWidget * XkorMatchDelegate::createEditor(QWidget * parent, const QStyleOptionViewItem &, const QModelIndex & index) const
{
	if(index.column() == 1 || index.column() == 2)
	{
		QSpinBox * spinBox = new QSpinBox(parent);
		spinBox->setFrame(false);
		return spinBox;
	}
	else
	{
		QLineEdit * lineEdit = new QLineEdit(parent);
		lineEdit->setFrame(false);
		return lineEdit;
	}
}

void XkorMatchDelegate::setEditorData(QWidget * editor, const QModelIndex & index) const
{
	if(index.column() == 1 || index.column() == 2)
	{
		QSpinBox * spinBox = qobject_cast<QSpinBox *>(editor);
		spinBox->setValue(index.model()->data(index, Qt::DisplayRole).toInt());
	}
	else
	{
		QLineEdit * lineEdit = qobject_cast<QLineEdit *>(editor);
		lineEdit->setText(index.model()->data(index, Qt::DisplayRole).toString());
	}
}

void XkorMatchDelegate::setModelData(QWidget * editor, QAbstractItemModel * model, const QModelIndex & index) const
{
	if(index.column() == 1 || index.column() == 2)
	{
		QSpinBox * spinBox = qobject_cast<QSpinBox *>(editor);
		model->setData(index, spinBox->value());
	}
	else
	{
		QLineEdit * lineEdit = qobject_cast<QLineEdit *>(editor);
		model->setData(index, lineEdit->text());
	}
}
