#ifndef MATCHWIDGET_H
#define MATCHWIDGET_H

#include <QAction>
#include <QToolButton>

#include "abstracttreewidget.h"
#include "tablegenerator/tablematch.h"

class XkorMatchWidget : public XkorAbstractTreeWidget
{
	Q_OBJECT
	
	protected:
		QAction * importAction;
		QToolButton * importButton;
		
		virtual void initItem(QTreeWidgetItem * item) { initItem(item, QString(), 0, 0, QString()); }
		virtual void initItem(QTreeWidgetItem * item, QString home, double homeScore, double awayScore, QString away);
		virtual void setupLayout();
		virtual QString insertionText() { return tr("Add match"); }
		virtual QString deletionText() { return tr("Remove matches"); }
		virtual QString movingUpText() { return tr("Move match up"); }
		virtual QString movingDownText() { return tr("Move match down"); }
		
	protected slots:
		void importMatches();
	
	public:
		XkorMatchWidget();
		std::vector<XkorTableMatch> matches();
		void setMatches(std::vector<XkorTableMatch> c);
};

#endif
