#include "tablegenerator/sortcriteriawidget.h"

#include "tablegenerator/sortcriteriadelegate.h"

XkorSortCriteriaWidget::XkorSortCriteriaWidget()
{
	sortTypes << "awayGoals" << "goalAverage" << "goalDifference" << "goalsFor" << "h2hAwayGoals" << "h2hGoalDifference" << "h2hGoalsFor" << "h2hPoints" << "h2hWins" << "points" << "winPercent" << "wins";
	sortNames << tr("Away goals") << tr("Goal average") << tr("Goal difference") << tr("Goals for") << tr("Head-to-head away goals") << tr("Head-to-head goal difference") << tr("Head-to-head goals for") << tr("Head-to-head points") << tr("Head-to-head wins") << tr("Points") << tr("Win percentage") << tr("Wins");
	
	treeWidget->setColumnCount(1);
	treeWidget->setItemDelegate(new XkorSortCriteriaDelegate(sortTypes, sortNames));
	treeWidget->setHeaderHidden(true);
	
	setupLayout();
}

void XkorSortCriteriaWidget::initItem(QTreeWidgetItem * item, QString sortType)
{
	item->setData(0, 1093, sortType);
	
	// get the name of the sort type
	int n = sortTypes.indexOf(sortType);
	if(n >= 0 && n < sortNames.size())
		item->setText(0, sortNames[n]);
	else
		item->setText(0, tr("<unknown sort type %1>").arg(sortType));
}

std::vector<QString> XkorSortCriteriaWidget::sortCriteria()
{
	std::vector<QString> rval;
	for(QTreeWidgetItemIterator i(treeWidget); *i; ++i)
		rval.push_back((*i)->data(0, 1093).toString());
	return rval;
}

void XkorSortCriteriaWidget::setSortCriteria(std::vector<QString> sc)
{
	isInUse = true;
	treeWidget->clear();
	for(std::vector<QString>::iterator i = sc.begin(); i != sc.end(); ++i)
	{
		QTreeWidgetItem * item = new QTreeWidgetItem(treeWidget);
		item->setFlags(item->flags() | Qt::ItemIsEditable);
		initItem(item, *i);
	}
	isInUse = false;
	emit listChanged();
}
