#ifndef TABLECOLUMNSWIDGET_H
#define TABLECOLUMNSWIDGET_H

#include <vector>

#include "abstracttreewidget.h"
#include "tablegenerator/tablecolumn.h"

class XkorTableColumnsWidget : public XkorAbstractTreeWidget
{
	Q_OBJECT
	
	protected:
		QStringList columnNames, columnTypes;
		
		virtual void initItem(QTreeWidgetItem * item) { initItem(item, QString(), QString(), 0); }
		virtual void initItem(QTreeWidgetItem * item, QString columnType, QString heading, uint width);
		virtual QString insertionText() { return tr("Add column"); }
		virtual QString deletionText() { return tr("Remove columns"); }
		virtual QString movingUpText() { return tr("Move column up"); }
		virtual QString movingDownText() { return tr("Move column down"); }
	
	public:
		XkorTableColumnsWidget();
		std::vector<XkorTableColumn> columns();
		void setColumns(std::vector<XkorTableColumn> c);
};

#endif
