#include "xmleventhandler.h"

bool XkorXmlEventHandler::endElement(const QString &, const QString & localName, const QString &)
{
	if(localName == "list")
	{
		startLists.push_back(values["list"]);
		values["list"].clear();
	}
	else if(localName == "group")
	{
		groups.push_back(currentGroup);
		currentGroup = XkorGroup();
	}
	else if(localName == "groupName")
	{
		currentGroup.name = values["groupName"];
		values["groupName"].clear();
	}
	else if(localName == "athlete")
	{
		currentGroup.athletes.push_back(values["athlete"]);
		values["athlete"].clear();
	}
	openTags.erase(localName);
	return true;
}

QString XkorXmlEventHandler::getSport()
{
	return values["sport"];
}

std::vector<QString> XkorXmlEventHandler::getStartLists()
{
	return startLists;
}

std::vector<XkorGroup> XkorXmlEventHandler::getGroups()
{
	return groups;
}

QString XkorXmlEventHandler::getRpbonus()
{
	return values["rpbonus"];
}

QString XkorXmlEventHandler::getOutput()
{
	return values["output"];
}
