#include "xml/xmlsporthandler.h"

bool XkorXmlSportHandler::startElement(const QString &, const QString & localName, const QString &, const QXmlAttributes & atts)
{
	if(localName == "dataPoints")
	{
		displayDigits.push_back(atts.value("displayDigits").isEmpty() ? 0 : atts.value("displayDigits").toUInt());
		precision.push_back(atts.value("precision").isEmpty() ? 1 : atts.value("precision").toDouble());
		scoreType.push_back(atts.value("scoreType").isEmpty() ? "rank" : atts.value("scoreType"));
	}
	else if(localName == "dataPoint")
		values["dataPoint>pos"] = atts.value("pos");
	
	openTags.insert(localName);
	return true;
}

bool XkorXmlSportHandler::endElement(const QString &, const QString & localName, const QString &)
{
	if(localName == "dataPoints")
	{
		dataPoints.push_back(dataPointGroup);
		dataPointGroup.clear();
	}
	else if(localName == "dataPoint")
	{
		dataPointGroup.insert(std::make_pair(values["dataPoint>pos"].toDouble(), values["dataPoint"].toDouble()));
		values["dataPoint"].clear();
		values["dataPoint>pos"].clear();
	}
	openTags.erase(localName);
	return true;
}

std::vector<std::map<double, double> > XkorXmlSportHandler::getDataPoints()
{
	return dataPoints;
}

std::vector<uint> XkorXmlSportHandler::getDisplayDigits()
{
	return displayDigits;
}

std::vector<double> XkorXmlSportHandler::getPrecision()
{
	return precision;
}

std::vector<QString> XkorXmlSportHandler::getScoreType()
{
	return scoreType;
}
