#ifndef XMLSPORTHANDLER_H
#define XMLSPORTHANDLER_H

#include <vector>
#include "xml/xmlbasehandler.h"

class XkorXmlSportHandler : public XkorXmlBaseHandler
{
	protected:
		std::vector<std::map<double, double> > dataPoints;
		std::map<double, double> dataPointGroup;
		std::vector<uint> displayDigits;
		std::vector<double> precision;
		std::vector<QString> scoreType;
	public:
		bool startElement(const QString & namespaceURI, const QString & localName, const QString & qName, const QXmlAttributes & atts);
		bool endElement(const QString & namespaceURI, const QString & localName, const QString & qName);
		std::vector<std::map<double, double> > getDataPoints();
		std::vector<uint> getDisplayDigits();
		std::vector<double> getPrecision();
		std::vector<QString> getScoreType();
};

#endif
