#ifndef XMLTABLEHANDLER_H
#define XMLTABLEHANDLER_H

#include <vector>
#include "tablegenerator/tablecolumn.h"
#include "tablegenerator/tablematch.h"
#include "xml/xmlbasehandler.h"

class XkorXmlTableHandler : public XkorXmlBaseHandler
{
	protected:
		std::vector<XkorTableColumn> columns;
		std::vector<XkorTableMatch> matches;
		std::vector<QString> sortCriteria;
	public:
		bool startElement(const QString & namespaceURI, const QString & localName, const QString & qName, const QXmlAttributes & atts);
		bool endElement(const QString & namespaceURI, const QString & localName, const QString & qName);
		std::vector<XkorTableMatch> getMatches();
		double getPointsForWin();
		double getPointsForDraw();
		double getPointsForLoss();
		std::vector<QString> getSortCriteria();
		std::vector<XkorTableColumn> getColumns();
};

#endif
